<?php
/*
@name Douilles 313MHz
@author Valentin CARRUESCO & robin5wood <idleman@idleman.fr> 
@link http://robin5wood.free.fr/cms/?Domotique___Commander_des_prises_avec_YANA
@licence CC by nc sa
@version 2.0.0
@description Douilles 313MHz
*/

include('douille.class.php');



function douille_plugin_setting_page(){
	global $_,$myUser;
	if(isset($_['section']) && $_['section']=='douille' ){

		if($myUser!=false){
			$douilleManager = new douille();
			$douilles = $douilleManager->populate();
			$roomManager = new Room();
			$rooms = $roomManager->populate();

			//Si on est en mode modification
			if (isset($_['id'])){
				$id_mod = $_['id'];
				$selected = $douilleManager->getById($id_mod);
				$description = $selected->GetName();
				$button = "Modifier";
			}
			//Si on est en mode ajout
			else
			{
				$description =  "Ajout d'une Douille 313MHz";
				$button = "Ajouter";
			}
			?>

			<div class="span9 userBloc">


				<h1>Douilles 313MHz</h1>
				<p>Gestion des Douilles 313MHz</p>  
				<form action="action.php?action=douille_add_douille" method="POST">
					<fieldset>
						<legend><? echo $description ?></legend>

						<div class="left">
							<label for="namedouille">Nom</label>
							<? if(isset($selected)){echo '<input type="hidden" name="id" value="'.$id_mod.'">';} ?>
							<input type="text" id="namedouille" value="<? if(isset($selected)){echo $selected->getName();} ?>" onkeyup="$('#vocalCommand').html($(this).val());" name="namedouille" placeholder="Lumiere Canapé…"/>
							<small>Commande vocale associée : "YANA, allume <span id="vocalCommand"></span>"</small>
							<label for="descriptiondouille">Description</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getDescription();} ?>" name="descriptiondouille" id="descriptiondouille" placeholder="Relais sous le canapé…" />
							<label for="telecommandeCodedouille">Code radio de la telecommande</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getTelecommandeCode();} ?>" name="telecommandeCodedouille" id="telecommandeCodedouille" placeholder="10000,11100,10101…" />
							<label for="priseCodedouille">Code radio de la prise</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getPriseCode();} ?>" name="priseCodedouille" id="priseCodedouille" placeholder="10000,01000,00100…" />
							<label for="roomdouille">Pièce</label>
							<select name="roomdouille" id="roomdouille">
								<?php foreach($rooms as $room){ 
									if (isset($selected)){$selected_room = ($selected->getRoom());}
									else{$selected_room = null;}			    		
									?>

									<option <? if ($selected_room == $room->getId()){echo "selected";} ?> value="<?php echo $room->getId(); ?>"><?php echo $room->getName(); ?></option>
									<?php } ?>
								</select>
							</div>

							<div class="clear"></div>
							<br/><button type="submit" class="btn"><? echo $button; ?></button>
						</fieldset>
						<br/>
					</form>

					<table class="table table-striped table-bordered table-hover">
						<thead>
							<tr>
								<th>Nom</th>
								<th>Description</th>
								<th>Code télécommande</th>
								<th>Code prise</th>
								<th>Pièce</th>
								<th>Status</th>
								<th></th>
							</tr>
						</thead>

						<?php foreach($douilles as $douille){ 

							$room = $roomManager->load(array('id'=>$douille->getRoom())); 
							?>
							<tr>
								<td><?php echo $douille->getName(); ?></td>
								<td><?php echo $douille->getDescription(); ?></td>
								<td><?php echo $douille->getTelecommandeCode(); ?></td>
								<td><?php echo $douille->getPriseCode(); ?></td>
								<td><?php echo $room->getName(); ?></td>
								<td><?php echo $douille->getPriseStatus(); ?></td>
								<td><a class="btn" href="action.php?action=douille_delete_douille&id=<?php echo $douille->getId(); ?>"><i class="icon-remove"></i></a>
									<a class="btn" href="setting.php?section=douille&id=<?php echo $douille->getId(); ?>"><i class="icon-edit"></i></a></td>
								</tr>
								<?php } ?>
							</table>
						</div>

						<?php }else{ ?>

						<div id="main" class="wrapper clearfix">
							<article>
								<h3>Vous devez être connecté</h3>
							</article>
						</div>
						<?php
					}
				}

			}

			function douille_plugin_setting_menu(){
				global $_;
				echo '<li '.(isset($_['section']) && $_['section']=='douille'?'class="active"':'').'><a href="setting.php?section=douille"><i class="icon-chevron-right"></i> Douille 313MHz</a></li>';
			}




			function douille_display($room){
				global $_;


				$douilleManager = new douille();
				$douilles = $douilleManager->loadAll(array('room'=>$room->getId()));

				foreach ($douilles as $douille) {

					?>

					<div class="span3 relayBloc">
						<h5 class="label label-info"><?php echo $douille->getName() ?></h5>	
						<p><?php echo $douille->getDescription() ?>
						</p><ul>
						<li>Type : <span>Prise commandee radio</span></li>
						<li>Code : <span class="label label-warning"><?php echo $douille->getTelecommandeCode() ?></span>&nbsp;<span class="label label-warning"><?php echo $douille->getPriseCode() ?></span></li>
						<li>Emplacement : <span><?php echo $room->getName() ?></span></li>
					</ul>
				<?php  if(fileperms(Plugin::path().'radioEmission')!='36333'){ ?><span style="width:98%" class="label label-important">Attention, les droits vers le fichier <br/> radioEmission sont mal réglés.<br/> Référez vous à <span style="cursor:pointer;text-decoration:underline;" onclick="window.location.href='https://github.com/ldleman/yana-server#installation';">la doc</span> pour les régler</span><?php } ?>
					
					<div class="btn-toolbar">
						<div class="btn-group">
							<a class="btn <?php if ($douille->getPriseStatus()) echo"btn-success"?>" href="action.php?action=douille_change_state&engine=<?php echo $douille->getId() ?>&amp;telecommande=<?php echo $douille->getTelecommandeCode() ?>&amp;prise=<?php echo $douille->getPriseCode() ?>&amp;state=on"><i class="icon-flash icon-white"></i></a>
						</div>
					</div>
				</div>


				<?php
			}
		}

		function douille_vocal_command(&$response,$actionUrl){
			$douilleManager = new douille();

			$douilles = $douilleManager->populate();
			foreach($douilles as $douille){
				$response['commands'][] = array('command'=>VOCAL_ENTITY_NAME.', toogle '.$douille->getName(),'url'=>$actionUrl.'?action=douille_change_state&engine='.$douille->getId().'&state=on&webservice=true','confidence'=>'0.9');
//				$response['commands'][] = array('command'=>VOCAL_ENTITY_NAME.', eteint '.$douille->getName(),'url'=>$actionUrl.'?action=douille_change_state&engine='.$douille->getId().'&state=off&webservice=true','confidence'=>'0.9');
			}
		}

		function douille_action_douille(){
			global $_,$conf,$myUser;

	//Mise à jour des droits
			$myUser->loadRight();

			switch($_['action']){
				case 'douille_delete_douille':
				if($myUser->can('Douilles 313MHz','d')){
					$douilleManager = new douille();
					$douilleManager->delete(array('id'=>$_['id']));
					header('location:setting.php?section=douille');
				}
				else
				{
					header('location:setting.php?section=douille&error=Vous n\'avez pas le droit de faire ça!');
				}

				break;
				case 'douille_plugin_setting':
				$conf->put('plugin_douille_emitter_pin',$_['emiterPin']);
				header('location: setting.php?section=preference&block=douille');
				break;

				case 'douille_add_douille':

				//Vérifie si on veut modifier ou ajouter un relai
				$right_toverify = isset($_['id']) ? 'u' : 'c';

				if($myUser->can('Douilles 313MHz',$right_toverify)){
					$douille = new douille();
					//Si modification on charge la ligne au lieu de la créer
					if ($right_toverify == "u"){$douille = $douille->load(array("id"=>$_['id']));}
					$douille->setName($_['namedouille']);
					$douille->setDescription($_['descriptiondouille']);
					$douille->setTelecommandeCode($_['telecommandeCodedouille']);
					$douille->setPriseCode($_['priseCodedouille']);
					$douille->setRoom($_['roomdouille']);
					$douille->save();
					header('location:setting.php?section=douille');
				}
				else
				{
					header('location:setting.php?section=douille&error=Vous n\'avez pas le droit de faire ça!');
				}


				break;

				case 'douille_change_state':
				global $_,$myUser;


				if($myUser->can('Douilles 313MHz','u')){
					$douille = new douille();
					$douille = $douille->getById($_['engine']);
					if($_['state']=='on'){
					$douille->setPriseStatus(1);
					}
					else{
					$douille->setPriseStatus(0);
					}
					$douille->save();
					$cmd = dirname(__FILE__).'/radioEmission '.$conf->get('plugin_douille_emitter_pin').' '.$douille->getTelecommandeCode().' '.$douille->getPriseCode().' '.$_['state'];

				//TODO change bdd state
					system('nohup '.$cmd.' &',$out);
					if(!isset($_['webservice'])){
						header('location:index.php?module=room&id='.$douille->getRoom());
					}else{
						$affirmations = array(	'A vos ordres!',
							'Bien!',
							'Oui commandant!',
							'Avec plaisir!',
							'J\'aime vous obéir!',
							'Avec plaisir!',
							'Certainement!',
							'Je fais ça sans tarder!',
							'Avec plaisir!',
							'Oui chef!');
						$affirmation = $affirmations[rand(0,count($affirmations)-1)];
						$response = array('responses'=>array(
							array('type'=>'talk','sentence'=>$affirmation)
							)
						);

						$json = json_encode($response);
						echo ($json=='[]'?'{}':$json);
					}
				}else{
					$response = array('responses'=>array(
						array('type'=>'talk','sentence'=>'Je ne vous connais pas, je refuse de faire ça!')
						)
					);
					echo json_encode($response);
				}
				break;
			}
		}


		function douille_plugin_preference_menu(){
			global $_;
			echo '<li '.(@$_['block']=='douille'?'class="active"':'').'><a  href="setting.php?section=preference&block=douille"><i class="icon-chevron-right"></i> Douille 313MHz</a></li>';
		}
		function douille_plugin_preference_page(){
			global $myUser,$_,$conf;
			if((isset($_['section']) && $_['section']=='preference' && @$_['block']=='douille' )  ){
				if($myUser!=false){
					?>

					<div class="span9 userBloc">
						<form class="form-inline" action="action.php?action=douille_plugin_setting" method="POST">

							<p>Pin du raspberry PI branché à l'émetteur radio: </p>
							<input type="text" class="input-large" name="emiterPin" value="<?php echo $conf->get('plugin_douille_emitter_pin');?>" placeholder="Pin wiring PI...">

							<button type="submit" class="btn">Enregistrer</button>
						</form>
					</div>

					<?php }else{ ?>

					<div id="main" class="wrapper clearfix">
						<article>
							<h3>Vous devez être connecté</h3>
						</article>
					</div>
					<?php

				}
			}
		}


		Plugin::addHook("preference_menu", "douille_plugin_preference_menu"); 
		Plugin::addHook("preference_content", "douille_plugin_preference_page"); 

		Plugin::addCss("/css/style.css"); 
		Plugin::addHook("action_post_case", "douille_action_douille"); 

		Plugin::addHook("node_display", "douille_display");   
		Plugin::addHook("setting_bloc", "douille_plugin_setting_page");
		Plugin::addHook("setting_menu", "douille_plugin_setting_menu");  
		Plugin::addHook("vocal_command", "douille_vocal_command");
		?>
